# presentation-form

Augmented.js Presentation Automatic Form View Module

# API

<!-- Generated by documentation.js. Update this documentation by updating the source code. -->

### Table of Contents

*   [AutomaticForm](#automaticform)
    *   [Parameters](#parameters)
    *   [\_retrieveSchema](#\_retrieveschema)
        *   [Parameters](#parameters-1)
        *   [Properties](#properties)
    *   [\_retrieveSchema](#\_retrieveschema-1)
        *   [Parameters](#parameters-2)
        *   [Properties](#properties-1)
    *   [\_retrieveSchema](#\_retrieveschema-2)
        *   [Parameters](#parameters-3)
        *   [Properties](#properties-2)
    *   [\_retrieveSchema](#\_retrieveschema-3)
        *   [Parameters](#parameters-4)
        *   [Properties](#properties-3)
    *   [\_retrieveSchema](#\_retrieveschema-4)
        *   [Parameters](#parameters-5)
        *   [Properties](#properties-4)
    *   [\_retrieveSchema](#\_retrieveschema-5)
        *   [Parameters](#parameters-6)
        *   [Properties](#properties-5)
    *   [\_retrieveSchema](#\_retrieveschema-6)
        *   [Parameters](#parameters-7)
        *   [Properties](#properties-6)
    *   [\_retrieveSchema](#\_retrieveschema-7)
        *   [Parameters](#parameters-8)
        *   [Properties](#properties-7)
    *   [\_retrieveSchema](#\_retrieveschema-8)
        *   [Parameters](#parameters-9)
        *   [Properties](#properties-8)
    *   [\_retrieveSchema](#\_retrieveschema-9)
        *   [Parameters](#parameters-10)
        *   [Properties](#properties-9)
    *   [\_retrieveSchema](#\_retrieveschema-10)
        *   [Parameters](#parameters-11)
        *   [Properties](#properties-10)
    *   [\_retrieveSchema](#\_retrieveschema-11)
        *   [Parameters](#parameters-12)
        *   [Properties](#properties-11)
    *   [setURI](#seturi)
        *   [Parameters](#parameters-13)
    *   [setSchema](#setschema)
        *   [Parameters](#parameters-14)
    *   [showProgressBar](#showprogressbar)
        *   [Parameters](#parameters-15)
    *   [showMessage](#showmessage)
        *   [Parameters](#parameters-16)
    *   [validate](#validate)
    *   [isValid](#isvalid)
    *   [render](#render)
    *   [reset](#reset)
    *   [populate](#populate)
        *   [Parameters](#parameters-17)
    *   [remove](#remove)
*   [formCompile](#formcompile)
    *   [Parameters](#parameters-18)

## AutomaticForm

**Extends DecoratorView**

A automatic form view created from a JSON Schema <br/>

Supported options:

<ul>
<li>schema - The JSON Schema for use with the UI and validation</li>
<li>data - prepopulate the model data</li>
<li>crossOrigin - Set CORS for the fetch</li>
<li>uri - the uri to fetch data from </li>
<li>title - the title of the form</li>
<li>description - set a tooltip for the form</li>
<li>display - Array of fields to display (others are hidden)</li>
<li>nestedInput - label wraps the input</li>
<li>submitButton - set the name of the submit button (binds to a submit method)</li>
<li>submitPrimary - set the submit button to primary (default)</li>
<li>resetButton - set the name of the reset button (binds to a reset method)</li>
<li>legacy - set legacy rendering (older look and feel)</li>
<li>large - render large input fields</li>
</ul>

### Parameters

*   `options` **[Object](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object)** Options for the class

### \_retrieveSchema

The crossOrigin property - enables cross origin fetch

#### Parameters

*   `uri`  

#### Properties

*   `crossOrigin` **[boolean](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Boolean)** The crossOrigin property

### \_retrieveSchema

The URI property

#### Parameters

*   `uri`  

#### Properties

*   `uri` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** The URI property

### \_retrieveSchema

The model property

#### Parameters

*   `uri`  

#### Properties

*   `model` **Model** The model property

### \_retrieveSchema

The initialized property

#### Parameters

*   `uri`  

#### Properties

*   `isInitalized` **[boolean](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Boolean)** The initialized property

### \_retrieveSchema

The title property

#### Parameters

*   `uri`  

#### Properties

*   `title` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** The title of the form

### \_retrieveSchema

The name property

#### Parameters

*   `uri`  

#### Properties

*   `name` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** The name of the form

### \_retrieveSchema

The description property

#### Parameters

*   `uri`  

#### Properties

*   `description` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** The description of the form

### \_retrieveSchema

#### Parameters

*   `uri`  

#### Properties

*   `display` **[array](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Array)** Fields to display - null will display all

### \_retrieveSchema

#### Parameters

*   `uri`  

#### Properties

*   `nestedInput` **[boolean](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Boolean)** Sets the input field as a chile of the label (defaults to false)

### \_retrieveSchema

#### Parameters

*   `uri`  

#### Properties

*   `submitButton` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** The name of the submit button (defaults to null)

### \_retrieveSchema

#### Parameters

*   `uri`  

#### Properties

*   `resetButton` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** The name of the reset button (defaults to null)

### \_retrieveSchema

#### Parameters

*   `uri`  

#### Properties

*   `legacy` **[boolean](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Boolean)** set legacy rendering

### setURI

Sets the URI

#### Parameters

*   `uri` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** The URI

**Meta**

*   **deprecated**: Use property

### setSchema

Sets the schema

#### Parameters

*   `schema` **[object](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object)** The JSON schema of the dataset

### showProgressBar

Enable/Disable the progress bar

#### Parameters

*   `show` **[boolean](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Boolean)** Show or Hide the progress bar

### showMessage

Show a message related to the form

#### Parameters

*   `message` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** Some message to display

### validate

Validate the form

Returns **[boolean](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Boolean)** Returns true on success of validation

### isValid

Is the form valid

Returns **[boolean](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Boolean)** Returns true if valid

### render

Render the form

Returns **[object](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object)** Returns the view context ('this')

### reset

Reset the form

Returns **[object](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object)** Returns the view context ('this')

### populate

Populate the form

#### Parameters

*   `data` **[object](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object)** Data to fill in

Returns **[object](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object)** Returns the view context ('this')

### remove

Remove the form and all binds

## formCompile

### Parameters

*   `name` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** Name of the form
*   `description` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** A description
*   `fields` **[object](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object)** Object of fields with types (see JSON scheme properties format)
*   `model` **[object](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object)** Data for the fields by key
*   `required` **[array](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Array)** Array of requires fields
*   `binding` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** Name of the binding function
*   `display` **[array](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Array)** Array of fields to display
*   `nestedInput` **Dom** Dom tree of nested markup
*   `submitButton` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** Name of the Submit button
*   `resetButton` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** Name of the reset button
*   `style` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** Name of styles
*   `tagName` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** Name of tag
*   `legacy` **[boolean](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Boolean)** Set old markup style (optional, default `false`)
*   `large`   (optional, default `false`)
*   `submitPrimary` **[boolean](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Boolean)** Set submit to primary (optional, default `true`)

Returns **Dom** Dom tree of form elements
